﻿using Kivii;
using Kivii.Linq;
using Kivii.Products.Entities;
using Kivii.Standards.Entities;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Domain.Lac.Lims.Extensions
{
    internal static class DetectionExtension
    {
        //根据GoodsKvid获取到price,若价格不止一条，则返回-1
        public  static decimal GetPrice(Guid goodsKvid, List<Price> priceLists)
        {
            priceLists = priceLists.Where(o => o.GoodsKvid == goodsKvid).ToList();
            if (priceLists.Count < 1)
            {
                return -1;
            }
            else return priceLists.FirstOrDefault().Amount;
        }

        /// <summary>
        /// 获取标准值
        /// </summary>
        /// <param name="detection"></param>
        /// <param name="grade"></param>
        /// <param name="gradeSafety"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        public static string GetQualifiedValue(this Detection detection, string grade, string gradeSafety,List<DetectionValue> detetctionValues)
        {
            if (!detection.QualifiedValue.IsNullOrEmpty()) return detection.QualifiedValue;
            if (detetctionValues.Count == 0) return null;
            var detectionValues = detetctionValues.Where(o => o.DetectionKvid == detection.Kvid).ToList();
            if (detectionValues.IsNullOrEmpty()) return null;
            var detectionValueGrade = grade.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == grade);
            var detectionValueGradeSafety = gradeSafety.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == gradeSafety);
            //新增代码,用于判定当前标准值是否可下拉(不同规格)
            //标准值条件非优一合+ABC
            if (detectionValueGrade == null && detectionValueGradeSafety == null)
            {
                return "请选择对应标准值!";
            }
            if (detectionValueGrade != null)
            {
                if (!detetctionValues.Where(o => o.ParentKvid == detectionValueGrade.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
                return detectionValueGrade.QualifiedValue;
            }
            if (detectionValueGradeSafety != null)
            {
                if (!detetctionValues.Where(o => o.ParentKvid == detectionValueGradeSafety.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
                return detectionValueGradeSafety.QualifiedValue;
            }
            return null;

            //if (!detection.QualifiedValue.IsNullOrEmpty()) return detection.QualifiedValue;
            //if (detetctionValues.Count == 0) return null;
            //var detectionValues =detetctionValues.Where(o => o.DetectionKvid == detection.Kvid).ToList();
            //if (detectionValues.IsNullOrEmpty()) return null;
            //var detectionValueGrade =grade.IsNullOrEmpty()?null:detectionValues.FirstOrDefault(o => o.Condition == grade);
            //var detectionValueGradeSafety = gradeSafety.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == gradeSafety);
            ////新增代码,用于判定当前标准值是否可下拉(不同规格)
            //if (detectionValueGrade != null)
            //{
            //    if(!detetctionValues.Where(o=> o.ParentKvid == detectionValueGrade.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
            //    return detectionValueGrade.QualifiedValue;
            //}
            //if (detectionValueGradeSafety != null)
            //{
            //    if (!detetctionValues.Where(o => o.ParentKvid == detectionValueGradeSafety.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
            //    return detectionValueGradeSafety.QualifiedValue;
            //}
            //return null;
        }

        /// <summary>
        /// 获取标准值(升级)
        /// 加入功能等级条件
        /// </summary>
        /// <param name="detection"></param>
        /// <param name="grade"></param>
        /// <param name="gradeSafety"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        public static string GetQualifiedValueUpgrade(this Detection detection, string grade, string gradeSafety, string gradeFunction, List<DetectionValue> detectionValueAll)
        {
            if (!detection.QualifiedValue.IsNullOrEmpty()) return detection.QualifiedValue;
            if (detectionValueAll.Count == 0) return null;
            var detectionValues = detectionValueAll.Where(o => o.DetectionKvid == detection.Kvid).ToList();
            if (detectionValues.IsNullOrEmpty()) return null;
            var detectionValueGrade = grade.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == grade);
            var detectionValueGradeSafety = gradeSafety.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == gradeSafety);
            var detectionValueGradeFunction = gradeFunction.IsNullOrEmpty() ? null : detectionValues.FirstOrDefault(o => o.Condition == gradeFunction);
            //新增代码,用于判定当前标准值是否可下拉(不同规格)
            if (detectionValueGrade == null && detectionValueGradeSafety == null&& detectionValueGradeFunction==null)
            {
                return "请选择对应标准值!";
            }
            if (detectionValueGrade != null)
            {
                if (!detectionValueAll.Where(o => o.ParentKvid == detectionValueGrade.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
                return detectionValueGrade.QualifiedValue;
            }
            if (detectionValueGradeSafety != null)
            {
                if (!detectionValueAll.Where(o => o.ParentKvid == detectionValueGradeSafety.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
                return detectionValueGradeSafety.QualifiedValue;
            }
            if (detectionValueGradeFunction != null)
            {
                if (!detectionValueAll.Where(o => o.ParentKvid == detectionValueGradeFunction.Kvid).ToList().IsNullOrEmpty()) return "请选择对应标准值!";
                return detectionValueGradeFunction.QualifiedValue;
            }
            return null;
        }
    }
}
